/*
 *  main.m
 *  ObjCOSC
 *
 *  Created by C. Ramakrishnan on Tue Oct 01 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */

#import <ObjCOSC/OSCPort.h>
#import <ObjCOSC/OSCInPort.h>
#import <ObjCOSC/OSC-string-help.h>
 
//#define portno 57123
//#define portno 57110
#define portno 57120

void PrintOSCArgs(int arglen, const void* args)
{
	const char* myArgTypes = (const char*) args;
	const char* myArgs = myArgTypes + OSCPaddedStrlen(myArgTypes);
	
	while (*myArgTypes != '\0') {

		switch (*myArgTypes) {
			case 'i':
				NSLog(@"\t\tread int %i", *((const int*)myArgs));
				myArgs += sizeof(int);
				break;
			case 'f':
				NSLog(@"\t\tread float %f", *((const float*)myArgs));
				myArgs += sizeof(float);			
				break;
			case 's':
				NSLog(@"\t\tread string %s", myArgs);
				myArgs += OSCPaddedStrlen(myArgs);						
				break;
		}
		myArgTypes++;
	}
}

void FooBarCallback(void *context, int arglen, const void *args, 
	OSCTimeTag when, NetworkReturnAddressPtr returnAddr)
{
	// Don't actually use context, but if i did, it's an NSString, since
	// that's what I passed in below
	// NSString* theContext = (NSString*)context;
	char myArgs[arglen];
	strncpy(myArgs, args, arglen);
	NSLog(@"\tCalled /foo/bar");
	PrintOSCArgs(arglen, args);
}

void BazCallback(void *context, int arglen, const void *args, 
	OSCTimeTag when, NetworkReturnAddressPtr returnAddr)
{
	char myArgs[arglen];
	strncpy(myArgs, args, arglen);
	NSLog(@"\tCalled /baz");
	PrintOSCArgs(arglen, args);	
}

// run dumpOSC and connect it to the portno
int main (int argc, char** argv)
{
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];

    char address[16];
    unsigned short	portNumber = portno;
	NSString* nsAddrString = @"/an/ns/string";
	NSString* nsTypesString = @"s";
	NSString* nsString = @"an NSString";

		// set the address
	memset(address, 0, sizeof(address));
    strcpy(address, "127.0.0.1");	// loopback address	
	
    
	NSLog(@"Connecting to %s:%hu...", address, portNumber);
	OSCInPort*  portIn = [[OSCInPort alloc] initPort: portNumber];
	OSCcontainer fooContainer = [portIn newContainerNamed: "foo"];
	[portIn newMethodNamed: "bar" under: fooContainer callback:FooBarCallback context: nsString];
	[portIn newMethodNamed: "baz" under: [portIn topLevelContainer] callback:BazCallback context: nsString];
	
	[portIn start];	
    OSCPort* 	port   = [OSCPort oscPortToAddress: address portNumber: portNumber];
    
	NSLog(@"Sending /foo/bar 128.4920...");	
    [port sendTo:"/foo/bar" types:"f", 128.4920];
	NSLog(@"Sending /baz a string...");
    [port sendTo:"/baz" types:"s", "a string"];
	NSLog(@"Sending /foo/bar* a string, 20, 9483.0249...");
    [port sendTo:"/foo/bar*" types:"sif", "a string", 20, 9483.0249];
	NSLog(@"Sending %@ %@...", nsAddrString, nsString);
	[port sendTo:[nsAddrString UTF8String] types:[nsTypesString UTF8String], [nsString UTF8String]];
	
//	[port loadSynthDef:"synthdefs/foo.scsyndef"];
//	[port newSynthFromDef:"foo" synthID:1000 parentGroup:0];
//	[port freeSynth:1000];
	
	[portIn stop];
    
    [pool release];

    return 0;
}

