//
//  OSCReceive.m
//  qtzosc
//
//  Created by satoru HIGA on 12/3/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "OSCReceive.h"

const int PortNO = 5500;
/*double inputPort_t;*/
OSCInPort *inPort = nil;

@interface OSCReceiveServer (priv)
- (void)initOSCReceivePort:(double)aPort;
@end

@implementation OSCReceiveServer

- (id)setup:(id)sender{
	/*[inputPort setDoubleValue:5500];
	inputPort_t = [inputPort doubleValue];*/
	[self initOSCReceivePort:PortNO];
	return sender;
}

- (void)cleanup:(id)sender{
	[inPort stop];
}

- (void)initOSCReceivePort:(double)aPort{
	//inputPort_t = aPort;
	[inPort stop];
	if(inPort){ [inPort dealloc]; inPort = nil; }
	inPort = [[OSCInPort alloc] initPort:(int)aPort];
	[inPort start];
}	

- (BOOL)execute:(QCOpenGLContext*)qcglctx time:(double)exec_time arguments:(id)arg{
	/*if(inputPort_t != [inputPort doubleValue]){
		[self initOSCReceivePort:[inputPort doubleValue]];
	}*/
	return TRUE;
}

+ (int)executionMode{ return 3;}
+ (BOOL)allowsSubpatches{ return NO;}

@end

@interface OSCRoute (priv)
- (void)initOSCOSCRouteTag:(NSString *)aString;
- (void)addMethodName:(NSString *)aName data:(NSMutableString *)aString;
@end

@implementation OSCRoute

void oscCallBack(void *context, int arglen, const void *vargs, OSCTimeTag when, NetworkReturnAddressPtr ra){
  char *p=(char *)vargs;
  int i=0,pointer=0;
  NSMutableString *dataString = (NSMutableString *)context;
  
  //NSLog(@" - %@",[dataString description]);
	
  pointer=((int)(strlen(p)/4)+1)*4-1;
  
  i=0;
  while(p[i]){
    switch(p[i]){
      case 'i':
      {
        int *tempint=(int *)vargs;
        int val;
        pointer+=sizeof(int);
        val=tempint[(int)(pointer/4)];
        [dataString setString:[NSString stringWithFormat:@"%d",val]];
      }
        break;
      case 'f':
      {
        float *tempfloat=(float *)vargs;
        float val;
        pointer+=sizeof(int);
        val=tempfloat[(int)(pointer/4)];
        [dataString setString:[NSString stringWithFormat:@"%f",val]];
      }
        break;
      case 's':
        pointer+=sizeof(char);
        [dataString setString:[NSString stringWithFormat:@"%s",(p+pointer)]];
        pointer+=((int)(strlen(p+pointer)/4)+1)*4-1;
        break;
    }
    i++;
  }
  //[collBackObject collbackOSCName:[dataArray objectAtIndex:0] data:dataString];
}

- (id)setup:(id)sender{
	[inputTag setStringValue:@"null"];
	[self initOSCOSCRouteTag:@""];
	DataString = [[NSMutableString alloc] init];
	return sender;
}

- (void)cleanup:(id)sender{
	if(OSCRouteTag) [OSCRouteTag release];
	if(DataString) [DataString release];
}

- (void)initOSCOSCRouteTag:(NSString *)aString{
	if(OSCRouteTag){
		[OSCRouteTag release];
		OSCRouteTag = nil;
	}
	OSCRouteTag = [[NSString stringWithString:aString] retain];
	[self addMethodName:OSCRouteTag data:DataString];
}

- (BOOL)execute:(QCOpenGLContext*)qcglctx time:(double)exec_time arguments:(id)arg{
	if(![OSCRouteTag isEqualToString:[inputTag stringValue]]){
		if([[inputTag stringValue] isEqualToString:@""]) [inputTag setStringValue:@"null"];
		[self initOSCOSCRouteTag:[inputTag stringValue]];
	}
	
	[outputMessage setStringValue:DataString];
	return TRUE;
}

- (void)addMethodName:(NSString *)aName data:(NSMutableString *)aString{
	if(![aName isEqualToString:@""]){
		char *tempCString=malloc(sizeof(char)*[aName cStringLength]);
		strcpy(tempCString,[aName cString]);
		[inPort newMethodNamed:tempCString
										 under:[inPort topLevelContainer]
									callback:oscCallBack
									 context:(void *)aString];
		//NSLog(@"Method %@", aName);
		[inPort start];
	}
}

+ (int)executionMode{ return 2;}
+ (BOOL)allowsSubpatches{ return NO;}

@end